openapi: 3.1.0
info:
  title: latency.gg public Probe API
  version: "0.0.0-local"
  description: |
    Specification for the latency.gg Probe service

  contact:
    name: latency.gg
    email: info@latency.gg
  
  license:
    name: WTFPL
    url: http://www.wtfpl.net/txt/copying

servers:
  - url: https://probe.latency.gg
  - url: https://probe.latency.dev

paths:
  /record/v4/{beacon_ip}:
    parameters:
    - name: beacon_ip
      in: path
      required: true
      schema:
        type: string
        format: ipv4
    post:
      operationId: submit-measurement-v4
      summary: |
        Submit a new measurement
      requestBody:
        required: true
        content:
          "application/json":
            schema: { $ref: "#/components/schemas/sample" }      
      responses:
        "202":
          description: Accepted
          content:
            application/json:
              schema: { $ref: "#/components/schemas/sample" }

  /record/v6/{beacon_ip}:
    parameters:
    - name: beacon_ip
      in: path
      required: true
      schema:
        type: string
        format: ipv6
    post:
      operationId: submit-measurement-v6
      summary: |
        Submit a new measurement
      requestBody:
        required: true
        content:
          "application/json":
            schema: { $ref: "#/components/schemas/sample" }      
      responses:
        "202":
          description: Accepted
          content:
            application/json:
              schema: { $ref: "#/components/schemas/sample" }


components:
  schemas:
    sample:
      type: object
      additionalProperties: false
      required:
       - type
       - version
       - ip
       - ident
       - rtt
       - stddev
      properties:
        type:
          description: The type of ping used
          type: string
          default: udp-data
          enum:
                - icmp
                - udp-data
                - udp-asymmetric
                - tcp-connect
                - tcp-data
                - tcp-asymmetric
        version:
          description: The version of the probe sdk
          type: string
          default: v1.0.0
        ip:
          description: The probe's IP address (v4 or v6)
          type: string
        ident:
          description: The probe's ident
          type: string
        raw:
          description: The raw data
          type: object
        rtt:
          description: The average RTT of the measurement in milliseconds
          type: integer
        stddev:
          description: The Standard Deviation of the measurement
          type: number
